''*****************************
''*  Graphics Demo            *
''*  (C) 2005 Parallax, Inc.  *
''*****************************

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = (100) >> 2   'accomodate display memory and stack

  PROTOBOARDPINS=%001_0101
  HYDRAPINS=%011_0000

  PAL=%0001
  NTSC=%0000
  INTERLACED=%0010

  COGS = 6

  x_tiles = 20 '*16=320
  y_tiles = 30 '*16=480
  mode = PAL | INTERLACED
  modepins = PROTOBOARDPINS

  paramcount = 15       

OBJ
  tv    : "JB_tv_02.spin"
  fant  : "JB_001_sw_fantasia_drv_001.spin"

VAR
    word    xd[2]
    word    yd[2]
    long    rnd
    byte    colors[70]
    word    pad
    
PUB Main | i,chroma,luma

    fant.start(COGS,@tvparams)

    tv.start(@tvparams)

    i:=0
    repeat luma from 2 to 7
        colors[i++]:=luma
    repeat luma from 11 to 14
        repeat chroma from 0 to 15
            colors[i++]:=chroma*16+luma

    rnd:=$24559f37
    Wait(60)
    repeat
        fant.NewString(0,$180,$200,string("Welcome to..."),10,3)
        Wait(180)
        fant.NewString(1,$380,$600,string("F"),0,3)
        fant.NewString(2,$480,$600,string("a"),2,3)
        fant.NewString(3,$580,$600,string("n"),4,3)
        fant.NewString(4,$680,$600,string("t"),6,3)
        fant.NewString(5,$780,$600,string("a"),8,3)
        fant.NewString(6,$880,$600,string("s"),10,3)
        fant.NewString(7,$980,$600,string("i"),12,3)
        fant.NewString(8,$a80,$600,string("a"),14,3)
        fant.NewString(9,$b80,$600,string("!"),0,3)
        Wait(10)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeleteString(0)
        Wait(180)
        fant.NewString(1,$0,$0,   string("F"),0,2)
        fant.NewString(2,$100,$0, string("a"),2,2)
        fant.NewString(3,$200,$0, string("n"),4,2)
        fant.NewString(4,$300,$0, string("t"),6,2)
        fant.NewString(5,$400,$0, string("a"),8,2)
        fant.NewString(6,$500,$0, string("s"),10,2)
        fant.NewString(7,$600,$0, string("i"),12,2)
        fant.NewString(8,$700,$0, string("a"),14,2)
        fant.NewString(0,$900,$0, string("is a"),10,1)
        fant.NewString(9,$0,$200, string("TV driver for"),10,1)
        fant.NewString(10,$0,$400,string("displaying text."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string(" "),10,1)
        fant.NewString(9,$0,$200, string("supports an 86"),10,1)
        fant.NewString(10,$0,$400,string("color display."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string(" "),10,1)
        fant.NewString(9,$0,$200, string("displays text on"),10,1)
        fant.NewString(10,$0,$400,string("the fly so does"),10,1)
        fant.NewString(11,$0,$600,string("not need a frame"),10,1)
        fant.NewString(12,$0,$800,string("buffer."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string("doesn't"),10,1)
        fant.NewString(9,$0,$200, string("use a tile map  "),10,1)
        fant.NewString(10,$0,$400,string("so text can be"),10,1)
        fant.NewString(11,$0,$600,string("displayed"),10,1)
        fant.NewString(12,$0,$800,string("anywhere on the"),10,1)
        fant.NewString(13,$0,$a00,string("screen."),10,1)
        Wait(180)
        repeat 5
            repeat i from $00 to $240 step 16
                Wait(1)
                fant.DeltaStringPos(12,$0,+4)    
                fant.DeltaStringPos(13,$0,+8)    
            repeat i from $00 to $200 step 16
                Wait(1)
                fant.DeltaStringPos(12,$0,-4)
                fant.DeltaStringPos(13,$0,-8)
        Wait(60)
        fant.NewString(0,$0,$0,   string("(Well almost.   "),10,1)
        fant.NewString(1,$0,$200, string("Horizontal"),10,1)
        fant.NewString(2,$0,$400,string("granularity is"),10,1)
        fant.NewString(3,$0,$600,string("4 pixels"),10,1)
        fant.NewString(4,$0,$800,string("for efficiency"),10,1)
        fant.NewString(5,$0,$a00,string("reasons.)"),10,1)
        fant.DeleteString(6)
        fant.DeleteString(7)
        fant.DeleteString(8)
        fant.DeleteString(9)
        fant.DeleteString(10)
        fant.DeleteString(11)
        fant.DeleteString(12)
        fant.DeleteString(13)
        Wait(180)
        repeat 3
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringTo(3,i,$600)    
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringTo(3,$600-i,$600)
        Wait(120)
        fant.NewString( 0,$380,$600,string("F"),0,3)
        fant.NewString( 1,$480,$600,string("a"),2,3)
        fant.NewString( 2,$580,$600,string("n"),4,3)
        fant.NewString( 3,$680,$600,string("t"),6,3)
        fant.NewString( 4,$780,$600,string("a"),8,3)
        fant.NewString( 5,$880,$600,string("s"),10,3)
        fant.NewString( 6,$980,$600,string("i"),12,3)
        fant.NewString( 7,$a80,$600,string("a"),14,3)
        fant.NewString( 8,$b80,$600,string("!"),0,3)
        fant.NewString( 9,$080,$200,string("a"),2,3)
        fant.NewString(10,$180,$200,string("b"),4,3)
        fant.NewString(11,$280,$200,string("c"),6,3)
        fant.NewString(12,$380,$200,string("d"),8,3)
        fant.NewString(13,$480,$200,string("e"),6,3)
        fant.NewString(14,$580,$200,string("f"),4,3)
        fant.NewString(15,$680,$200,string("g"),2,3)
        fant.NewString(16,$780,$200,string("h"),4,3)
        fant.NewString(17,$880,$200,string("i"),6,3)
        fant.NewString(18,$980,$200,string("j"),8,3)
        fant.NewString(19,$a80,$200,string("k"),6,3)
        fant.NewString(20,$b80,$200,string("l"),4,3)
        fant.NewString(21,$180,$400,string("m"),2,3)
        fant.NewString(22,$280,$400,string("n"),4,3)
        fant.NewString(23,$380,$400,string("o"),6,3)
        fant.NewString(24,$480,$400,string("p"),8,3)
        fant.NewString(25,$580,$400,string("q"),6,3)
        fant.NewString(26,$680,$400,string("r"),4,3)
        fant.NewString(27,$780,$400,string("s"),2,3)
        fant.NewString(28,$880,$400,string("t"),4,3)
        fant.NewString(29,$980,$400,string("u"),6,3)
        fant.NewString(30,$a80,$400,string("v"),8,3)
        fant.NewString(31,$b80,$400,string("w"),6,3)
        Wait(240)
        repeat 800
            Wait(1)      
            repeat i from 0 to 31
                fant.DeltaStringPos(i,lookupz(i&7:-15,+20,-5,+30,-25,9,-10,15,-20),lookupz(i&7:10,-15,20,-5,10,10,-15,20,-10))
    
PRI Wait(aTime) | target
    {{
    Waits for a time specified in thousanths of a second
    }}
    repeat aTime
        byte[@tvparams]:=0
        repeat until byte[@tvparams]>0

'    repeat 150
'    bordercolour:=$2b
'    repeat 150
'    bordercolour:=$4e
    
  

DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
                        long    mode            'mode
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    50_000_000'_xinfreq<<4  'broadcast
                        long    0               'auralcog
                        long    @hub_scanline_buffer+$10
                        long    @bordercolour+$10  'pointer to border colour
                        long    @nextline+$10

nextline                long    0                        

bordercolour            long    $02 '2b '02

hub_scanline_buffer     long
colorbar0               long    $0b_0b_0b_0b
colorbar1               long    $0c_0c_0c_0c
colorbar2               long    $0d_0d_0d_0d
colorbar3               long    $0e_0e_0e_0e
colorbar4               long    $1b_0b_1b_1b
colorbar5               long    $1c_0c_1c_1c
colorbar6               long    $1d_0d_1d_1d
colorbar7               long    $1e_0e_1e_1e
colorbar8               long    $2b_0b_2b_2b
colorbar9               long    $2c_2c_2c_2c
colorbar10              long    $2d_2d_2d_2d
colorbar11              long    $2e_2e_2e_2e
colorbar12              long    $3b_3b_3b_3b
colorbar13              long    $3c_3c_3c_3c
colorbar14              long    $3d_3d_3d_3d
colorbar15              long    $3e_3e_3e_3e
colorbar16              long    $4b_4b_4b_4b
colorbar17              long    $4c_4c_4c_4c
colorbar18              long    $4d_4d_4d_4d
colorbar19              long    $4e_4e_4e_4e
colorbar20              long    $5b_5b_5b_5b
colorbar21              long    $5c_5c_5c_5c
colorbar22              long    $5d_5d_5d_5d
colorbar23              long    $5e_5e_5e_5e
colorbar24              long    $6b_6b_6b_6b
colorbar25              long    $6c_6c_6c_6c
colorbar26              long    $6d_6d_6d_6d
colorbar27              long    $6e_6e_6e_6e
colorbar28              long    $7b_7b_7b_7b
colorbar29              long    $7c_7c_7c_7c
colorbar30              long    $7d_7d_7d_7d
colorbar31              long    $7e_7e_7e_7e
colorbar32              long    $8b_8b_8b_8b
colorbar33              long    $8c_8c_8c_8c
colorbar34              long    $8d_8d_8d_8d
colorbar35              long    $8e_8e_8e_8e
colorbar36              long    $9b_9b_9b_9b
colorbar37              long    $9c_9c_9c_9c
colorbar38              long    $9d_9d_9d_9d
colorbar39              long    $9e_9e_9e_9e
colorbar40              long    $ab_ab_ab_ab
colorbar41              long    $ac_ac_ac_ac
colorbar42              long    $ad_ad_ad_ad
colorbar43              long    $ae_ae_ae_ae
colorbar44              long    $bb_bb_bb_bb
colorbar45              long    $bc_bc_bc_bc
colorbar46              long    $bd_bd_bd_bd
colorbar47              long    $be_be_be_be
colorbar48              long    $cb_cb_cb_cb
colorbar49              long    $cc_cc_cc_cc
colorbar50              long    $cd_cd_cd_cd
colorbar51              long    $ce_ce_ce_ce
colorbar52              long    $db_db_db_db
colorbar53              long    $dc_dc_dc_dc
colorbar54              long    $dd_dd_dd_dd
colorbar55              long    $de_de_de_de
colorbar56              long    $eb_eb_eb_eb
colorbar57              long    $ec_ec_ec_ec
colorbar58              long    $ed_ed_ed_ed
colorbar59              long    $ee_ee_ee_ee
colorbar60              long    $fb_fb_fb_fb
colorbar61              long    $fc_fc_fc_fc
colorbar62              long    $fd_fd_fd_fd
colorbar63              long    $fe_fe_fe_fe

colorbara0               long    $0b_0b_0b_0b
colorbara1               long    $0c_0c_0c_0c
colorbara2               long    $0d_0d_0d_0d
colorbara3               long    $0e_0e_0e_0e
colorbara4               long    $1b_0b_1b_1b
colorbara5               long    $1c_0c_1c_1c
colorbara6               long    $1d_0d_1d_1d
colorbara7               long    $1e_0e_1e_1e
colorbara8               long    $2b_0b_2b_2b
colorbara9               long    $2c_2c_2c_2c
colorbara10              long    $2d_2d_2d_2d
colorbara11              long    $2e_2e_2e_2e
colorbara12              long    $3b_3b_3b_3b
colorbara13              long    $3c_3c_3c_3c
colorbara14              long    $3d_3d_3d_3d
colorbara15              long    $3e_3e_3e_3e
colorbara16              long    $4b_4b_4b_4b
colorbara17              long    $4c_4c_4c_4c
colorbara18              long    $4d_4d_4d_4d
colorbara19              long    $4e_4e_4e_4e
colorbara20              long    $5b_5b_5b_5b
colorbara21              long    $5c_5c_5c_5c
colorbara22              long    $5d_5d_5d_5d
colorbara23              long    $5e_5e_5e_5e
colorbara24              long    $6b_6b_6b_6b
colorbara25              long    $6c_6c_6c_6c
colorbara26              long    $6d_6d_6d_6d
colorbara27              long    $6e_6e_6e_6e
colorbara28              long    $7b_7b_7b_7b
colorbara29              long    $7c_7c_7c_7c
colorbara30              long    $7d_7d_7d_7d
colorbara31              long    $7e_7e_7e_7e
colorbara32              long    $8b_8b_8b_8b
colorbara33              long    $8c_8c_8c_8c
colorbara34              long    $8d_8d_8d_8d
colorbara35              long    $8e_8e_8e_8e
colorbara36              long    $9b_9b_9b_9b
colorbara37              long    $9c_9c_9c_9c
colorbara38              long    $9d_9d_9d_9d
colorbara39              long    $9e_9e_9e_9e
colorbara40              long    $ab_ab_ab_ab
colorbara41              long    $ac_ac_ac_ac
colorbara42              long    $ad_ad_ad_ad
colorbara43              long    $ae_ae_ae_ae
colorbara44              long    $bb_bb_bb_bb
colorbara45              long    $bc_bc_bc_bc
colorbara46              long    $bd_bd_bd_bd
colorbara47              long    $be_be_be_be
colorbara48              long    $cb_cb_cb_cb
colorbara49              long    $cc_cc_cc_cc
colorbara50              long    $cd_cd_cd_cd
colorbara51              long    $ce_ce_ce_ce
colorbara52              long    $db_db_db_db
colorbara53              long    $dc_dc_dc_dc
colorbara54              long    $dd_dd_dd_dd
colorbara55              long    $de_de_de_de
colorbara56              long    $eb_eb_eb_eb
colorbara57              long    $ec_ec_ec_ec
colorbara58              long    $ed_ed_ed_ed
colorbara59              long    $ee_ee_ee_ee
colorbara60              long    $fb_fb_fb_fb
colorbara61              long    $fc_fc_fc_fc
colorbara62              long    $fd_fd_fd_fd
colorbara63              long    $fe_fe_fe_fe

colourbar0               long    $0b_0b_0b_0b
colourbar1               long    $0c_0c_0c_0c
colourbar2               long    $0d_0d_0d_0d
colourbar3               long    $0e_0e_0e_0e
colourbar4               long    $1b_0b_1b_1b
colourbar5               long    $1c_0c_1c_1c
colourbar6               long    $1d_0d_1d_1d
colourbar7               long    $1e_0e_1e_1e
colourbar8               long    $2b_0b_2b_2b
colourbar9               long    $2c_2c_2c_2c
colourbar10              long    $2d_2d_2d_2d
colourbar11              long    $2e_2e_2e_2e
colourbar12              long    $3b_3b_3b_3b
colourbar13              long    $3c_3c_3c_3c
colourbar14              long    $3d_3d_3d_3d
colourbar15              long    $3e_3e_3e_3e
colourbar16              long    $4b_4b_4b_4b
colourbar17              long    $4c_4c_4c_4c
colourbar18              long    $4d_4d_4d_4d
colourbar19              long    $4e_4e_4e_4e
colourbar20              long    $5b_5b_5b_5b
colourbar21              long    $5c_5c_5c_5c
colourbar22              long    $5d_5d_5d_5d
colourbar23              long    $5e_5e_5e_5e
colourbar24              long    $6b_6b_6b_6b
colourbar25              long    $6c_6c_6c_6c
colourbar26              long    $6d_6d_6d_6d
colourbar27              long    $6e_6e_6e_6e
colourbar28              long    $7b_7b_7b_7b
colourbar29              long    $7c_7c_7c_7c
colourbar30              long    $7d_7d_7d_7d
colourbar31              long    $7e_7e_7e_7e
colourbar32              long    $8b_8b_8b_8b
colourbar33              long    $8c_8c_8c_8c
colourbar34              long    $8d_8d_8d_8d
colourbar35              long    $8e_8e_8e_8e
colourbar36              long    $9b_9b_9b_9b
colourbar37              long    $9c_9c_9c_9c
colourbar38              long    $9d_9d_9d_9d
colourbar39              long    $9e_9e_9e_9e
colourbar40              long    $ab_ab_ab_ab
colourbar41              long    $ac_ac_ac_ac
colourbar42              long    $ad_ad_ad_ad
colourbar43              long    $ae_ae_ae_ae
colourbar44              long    $bb_bb_bb_bb
colourbar45              long    $bc_bc_bc_bc
colourbar46              long    $bd_bd_bd_bd
colourbar47              long    $be_be_be_be
colourbar48              long    $cb_cb_cb_cb
colourbar49              long    $cc_cc_cc_cc
colourbar50              long    $cd_cd_cd_cd
colourbar51              long    $ce_ce_ce_ce
colourbar52              long    $db_db_db_db
colourbar53              long    $dc_dc_dc_dc
colourbar54              long    $dd_dd_dd_dd
colourbar55              long    $de_de_de_de
colourbar56              long    $eb_eb_eb_eb
colourbar57              long    $ec_ec_ec_ec
colourbar58              long    $ed_ed_ed_ed
colourbar59              long    $ee_ee_ee_ee
colourbar60              long    $fb_fb_fb_fb
colourbar61              long    $fc_fc_fc_fc
colourbar62              long    $fd_fd_fd_fd
colourbar63              long    $fe_fe_fe_fe

colourbara0               long    $0b_0b_0b_0b
colourbara1               long    $0c_0c_0c_0c
colourbara2               long    $0d_0d_0d_0d
colourbara3               long    $0e_0e_0e_0e
colourbara4               long    $1b_0b_1b_1b
colourbara5               long    $1c_0c_1c_1c
colourbara6               long    $1d_0d_1d_1d
colourbara7               long    $1e_0e_1e_1e
colourbara8               long    $2b_0b_2b_2b
colourbara9               long    $2c_2c_2c_2c
colourbara10              long    $2d_2d_2d_2d
colourbara11              long    $2e_2e_2e_2e
colourbara12              long    $3b_3b_3b_3b
colourbara13              long    $3c_3c_3c_3c
colourbara14              long    $3d_3d_3d_3d
colourbara15              long    $3e_3e_3e_3e
colourbara16              long    $4b_4b_4b_4b
colourbara17              long    $4c_4c_4c_4c
colourbara18              long    $4d_4d_4d_4d
colourbara19              long    $4e_4e_4e_4e
colourbara20              long    $5b_5b_5b_5b
colourbara21              long    $5c_5c_5c_5c
colourbara22              long    $5d_5d_5d_5d
colourbara23              long    $5e_5e_5e_5e
colourbara24              long    $6b_6b_6b_6b
colourbara25              long    $6c_6c_6c_6c
colourbara26              long    $6d_6d_6d_6d
colourbara27              long    $6e_6e_6e_6e
colourbara28              long    $7b_7b_7b_7b
colourbara29              long    $7c_7c_7c_7c
colourbara30              long    $7d_7d_7d_7d
colourbara31              long    $7e_7e_7e_7e
colourbara32              long    $8b_8b_8b_8b
colourbara33              long    $8c_8c_8c_8c
colourbara34              long    $8d_8d_8d_8d
colourbara35              long    $8e_8e_8e_8e
colourbara36              long    $9b_9b_9b_9b
colourbara37              long    $9c_9c_9c_9c
colourbara38              long    $9d_9d_9d_9d
colourbara39              long    $9e_9e_9e_9e
colourbara40              long    $ab_ab_ab_ab
colourbara41              long    $ac_ac_ac_ac
colourbara42              long    $ad_ad_ad_ad
colourbara43              long    $ae_ae_ae_ae
colourbara44              long    $bb_bb_bb_bb
colourbara45              long    $bc_bc_bc_bc
colourbara46              long    $bd_bd_bd_bd
colourbara47              long    $be_be_be_be
colourbara48              long    $cb_cb_cb_cb
colourbara49              long    $cc_cc_cc_cc
colourbara50              long    $cd_cd_cd_cd
colourbara51              long    $ce_ce_ce_ce
colourbara52              long    $db_db_db_db
colourbara53              long    $dc_dc_dc_dc
colourbara54              long    $dd_dd_dd_dd
colourbara55              long    $de_de_de_de
colourbara56              long    $eb_eb_eb_eb
colourbara57              long    $ec_ec_ec_ec
colourbara58              long    $ed_ed_ed_ed
colourbara59              long    $ee_ee_ee_ee
colourbara60              long    $fb_fb_fb_fb
colourbara61              long    $fc_fc_fc_fc
colourbara62              long    $fd_fd_fd_fd
colourbara63              long    $fe_fe_fe_fe